// Definitions
nkf.posx = new Array();
nkf.posy = new Array();
//speedx = Math.random() * nkf.maxstepx;
nkf.speedy = new Array();
nkf.active = new Array();
nkf.actives = nkf.rockets;
nkf.state = new Array();
nkf.delay = new Array();

nkf.maxwidth = window.innerWidth;
nkf.maxheight = window.innerHeight;
if (!nkf.maxwidth) {
	nkf.maxwidth = document.documentElement.clientWidth;
	nkf.maxheight = document.documentElement.clientHeight;
}
if (!nkf.maxwidth) {
	nkf.maxwidth = document.body.clientWidth;
	nkf.maxheight = document.body.clientHeight;
}

// Create some position + movement data
for (i = 0; i < nkf.rockets; i++) {
	// starting position
	nkf.posy[i] = nkf.maxheight + nkf.flakesize;
	nkf.posx[i] = nkf.maxwidth / nkf.rockets * i;
	// movement
	nkf.speedy[i] = 15 + Math.random() * (nkf.maxstepy);
	nkf.active[i] = true;
	// state (grounded, rocket, explosion)
	nkf.state[i] = 'grounded';
	// delay
	nkf.delay[i] = Math.random() * 20 * nkf.rockets;
}

if (window.onload) {
	nkf.oldonload = window.onload;
}
window.onload=function(){
	currentTime = new Date();
	nkf.endtime = currentTime.getTime() + nkf.maxtime;
	fireworks(nkf);
	if (nkf.oldonload) {
		nkf.oldonload();
	}
}

function fireworks(nkf) {
	currentTime = new Date();
	for (i = 0; i < nkf.rockets; i++) {
		if (nkf.active[i] === true) {
			if (nkf.state[i] == 'explosion') {
				nkf.delay[i]--;
				if (nkf.delay[i] <= 0) {
					nkf.delay[i] = Math.random() * 50;
					nkf.state[i] = 'grounded';
					nkf.posy[i] = nkf.maxheight + nkf.flakesize;
					document.getElementById('nkfireworks' + i).style.top=nkf.posy[i] + "px";
				}
			}
			else if (nkf.state[i] == 'rocket') {
				nkf.posy[i] = nkf.posy[i] - nkf.speedy[i];
				document.getElementById('nkfireworks' + i).style.top=nkf.posy[i] + "px";
				document.getElementById('nkfireworks' + i).style.left=nkf.posx[i] + "px";
				if (nkf.posy[i] < nkf.maxheight / 3) {
					if (Math.random() * 100 > 90 || nkf.posy[i] < 100) {
						nkf.delay[i] = 30;
						nkf.state[i] = 'explosion';
						// make invisible for changes??
						document.getElementById('nkfireworks' + i).style.top=nkf.posy[i] - nkf.flakesize / 2 +  "px";
						document.getElementById('nkfireworks' + i).style.left=nkf.posx[i] - nkf.flakesize / 2 + "px";
						document.getElementById('nkfireworks' + i).src='http://www.nkuttler.de/wp-content/plugins/nkfireworks/pics/fire' + Math.round(Math.random() * 2) + '.gif';
					}
				}
			}
			else if (nkf.state[i] == 'grounded') {
				nkf.delay[i]--;
				if (nkf.delay[i] <= 0) {
					nkf.state[i] = 'rocket';
					nkf.posx[i] = Math.random() * nkf.maxwidth;
					document.getElementById('nkfireworks' + i).src='http://www.nkuttler.de/wp-content/plugins/nkfireworks/pics/rocket.gif';
				}
				if (currentTime.getTime() > nkf.endtime) {
					nkf.active[i] = false;
					nkf.posy[i] = -nkf.flakesize;
					nkf.actives--;
				}
			}
		}
	}
	if (nkf.actives > 0) {
		window.setTimeout("fireworks(nkf)", nkf.timeout);
	}
}
